import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_button_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikButtonProps extends WidgetProps {
  late String id;
  Widget? text;
  Widget? icon;
  late Color borderColor = Color(0xFFFFD60A);
  late Color backgroundColor = Color(0xFFFFD60A);
  late double? borderRadius = 0.0;
  late double width = 0.0;
  late double? height = 0.0;
  late double? verticalPadding = 0.0;
  late double? horizontalPadding = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late UikAction action;

  UikButtonProps();

  factory UikButtonProps.fromJson(Map<String, dynamic> json) =>
      $UikButtonPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
